#! /usr/bin/perl -w

# convert_toc.pl converts old <<TOC>> marked up files to use the new
# <Section> syntax (suitable for processing by HTMLPlug -description_tags

my $level = 0;

sub main {
  open STDIN, "<$ARGV[0]" or die "$ARGV[0]: $!\n";
  open STDOUT, ">$ARGV[1]" or die "$ARGV[1]: $!\n";

  my $content = "";
  
  while (<STDIN>) {
    $_ =~ s/[\cJ\cM]+$//;
    $content .= $_;
  }

  # fix images
  $content =~ s/&lt;&lt;I&gt;&gt;\s*(\w+\.(?:png|jpe?g|gif))\s*(.*?)<\/p>/<center><img src=\"$1\"><br>$2<\/center><\/p>\n/igs;
  
  # process section title
  while ($content =~ s/(?:<P[^>]*>|<BR>)(?:\s*<\/?[^>]*>)*?&lt;&lt;TOC(\d+)&gt;&gt;(.*?)(?:\s*<\/?[^>]*>)*?\s*(<\/P[^>]*>|<BR>)/process_toc ($1, $2)/sige) {}
  
  # close the remaining sections
  my $section_ending = "<!--\n";
  for (my $j = 0; $j < $level; $j++) {
    $section_ending .= "</Section>\n";
  }
  $section_ending .= "-->\n";
  $content =~ s/(<\/body>)/$section_ending.$1/ie;

  print STDOUT $content;
  close STDOUT; close STDIN;
}

sub process_toc {
  my ($thislevel, $title) = @_;
  my $toc = '';
 
  $title =~ s/\n/ /g;
  $title =~ s/<[^>]+>//g;
  $title =~ s/^\s+//;
  $title =~ s/\s+$//;

  $toc .= "\n<!--\n";

  if ($thislevel <= $level) {
    for (my $i = 0; $i < ($level-$thislevel+1); $i++) {
	$toc .= "</Section>\n";
    }
  }
  $toc .= "<Section>\n".
	"  <Description>\n".
	"    <Metadata name=\"Title\">$title</Metadata>\n".
	"  </Description>\n".
	"-->\n";

  $level = $thislevel;
  
  return $toc;
}

&main;